
-- concept for the data (only for information, is only the example for the underlying error)

-- the data represent 3 different states of a schema definition of a target database (here anonymized)
-- oldcol: Original version with Mixed-case column Names
-- newcol: corresponding version with (manually) renamed columns in the saame order (nnum=onum)
-- varcol: part of the most recent schema definitions (now on postgres) containing only varchar columns
--			there are length changes, renames,deletions and additions of varchar columns over a long period (many years)

-- The goal was now to transfer the changed (augmented) length definitions from varcol to oldcol so that
-- the current data could be imported in the old schema

-- the join with varcol (inside qj) selects only still matching column names with like


-- The test queries:

-- first query:succeeds

-- explain analyze -- explain analyze verbose -- explain -- select * from ( -- select count(*) from ( -- select length(sel) from (
select * from (
select 
 onum
,vname
,vlen
,nlen
,olen
,NULLIF(vlen-olen,0) as delta_len
from (
select *
,('0'||split_part(split_part(nline,'(',2),')',1))::smallint as nlen
,('0'||split_part(split_part(oline,'(',2),')',1))::smallint as olen
from newcol
join oldcol on onum=nnum
join (
select
 vnum
,split_part(vline,' ',1) as vname
,('0'||split_part(split_part(vline,'(',2),')',1))::smallint as vlen
from varcol
) qv on nline like '%'||vname||'%'
where nline not like '%KEY%'
) qj
--limit 30
where vlen!=olen
) qcomp
--where
--nlen > 0
;


-- second query (only added a where clause!) FAILS with error

-- explain
select * from (
select 
 onum
,vname
,vlen
,nlen
,olen
,NULLIF(vlen-olen,0) as delta_len
from (
select *
,('0'||split_part(split_part(nline,'(',2),')',1))::smallint as nlen
,('0'||split_part(split_part(oline,'(',2),')',1))::smallint as olen
from newcol
join oldcol on onum=nnum
join (
select
 vnum
,split_part(vline,' ',1) as vname
,('0'||split_part(split_part(vline,'(',2),')',1))::smallint as vlen
from varcol
) qv on nline like '%'||vname||'%'
where nline not like '%KEY%'
) qj
--limit 30
where vlen!=olen
) qcomp
where
nlen > 0
;


